from flask import Flask,request,render_template,jsonify,redirect, url_for, session
import json
import os
import requests
import subprocess
import simple_sql
from wifi_utils import *
from flask_bootstrap import Bootstrap


# wifi device name
WIFI_DEVICE='wlan0'

app = Flask(__name__)
bootstrap = Bootstrap(app)
recent_dir = os.path.abspath(os.path.dirname(__file__))

wifi_list = []





def is_encrypted(cell):
    if(cell.security == '--'):
        return False
    else:
        return True
def getWifiCell(ssid):
    global wifi_list
    for cell in wifi_list:
        if cell.ssid == ssid:
            print(cell.ssid)
            return cell
    return None

def print_wifi():
    for cell in wifi_list:
        print(cell.ssid)


@app.route('/')
def index():
    ret = restart_wifi()
    if( ret == 1 ):        
        return redirect(url_for('wifi_scan'))
    elif( ret == 0 ):
        if (os.path.isfile('./storage/master_pin')):
            return redirect(url_for('main_page'))
        else:
            return redirect(url_for('pin_setup'))
    return "OK"


@app.route('/initial')
def initial():
    return render_template('t.html')


@app.route('/wifi_scan')
def wifi_scan():
    global wifi_list
    wifi_list = scan_wifi()
    return render_template('wifi.html', data=wifi_list)

@app.route('/wifi_select/<string:ssid>', methods=['GET'])
def wifi_pass(ssid):
    global wifi_list
    delete_connection(ssid)
    print("Ready for Connecting to {}".format(ssid))
    if wifi_list == None:
        wifi_list = scan_wifi()
    for i in wifi_list:
        print(i.ssid)
    cell = getWifiCell(ssid)
    if(cell is not None):
        return render_template('index.html', data=ssid,isEnc=is_encrypted(cell))
    else:
        return render_template('index.html', data="None",isEnc=True)
        #return redirect(url_for('index'))

@app.route('/wifi_select/', methods=['GET'])
def pass_without_ssid():
    return redirect(url_for('wifi_scan'))        

@app.route('/wifi_conn', methods=["POST"])
def wifi_conn():
    ssid = request.form.get('ssid')
    passwd = request.form.get('password')
    print("{} : {}".format(ssid, passwd))
    ret = wifi_connect(ssid,passwd)
    if ret is True:
        return "Connection Success",200
    else:
        return "Connection Failed",500
    return "Not Found",404

@app.route('/pin_setup', methods=['GET'])
def pin_setup():
    return render_template('pincode.html')
@app.route('/pincode_storage',methods=['POST'])
def pin_store():
    pin = request.form.get("pin")
    print(pin)
    if pin and len(pin) == 6:
        f = open('./storage/master_pin','w')
        f.write(pin)
        f.close()
        return "OK",200
    else:
        return "Your PINCODE is not acceptable",500

@app.route("/main_page", methods=['GET'])
def main_page():
    return render_template("main_page.html")
@app.route("/<string:otp>", methods=['GET'])
def otp(otp):    
    return render_template("otp.html", data=otp)

@app.route("/otp_check", methods=['POST'])
def check_otp():
    otp_type = request.form.get('type')
    otp = request.form.get('pin')
    print(otp_type, otp)
    return redirect(url_for('index'))



if __name__ == '__main__':        
    app.run(host='0.0.0.0', port=8080, debug=True)
